(* Copyright (c) 2002 INRIA *)
(* Author : Gaurav Chanda , Projet CRISTAL *)

(** This module gives the description of the [boolean_s] type. *)

(** This gives the general description of the [boolean_s_sig] class *)
class type boolean_s_sig = 
        object
             
             value mutable name : string ;
             (** This contains the name of the XML-element concerned *)
             
             value mutable v : bool ;
             (** This contains the value of the object *)
             
             value mutable whitespace : string ;
             (** This contains the information on how to handle white spaces *)

             method get_val : unit -> bool ;
             (** This function returns the value held by the object *)
             
             method set_obj : string -> unit ;
             (** Sets the value of the object with the given string after making
             other attribute checks *)
             
             method to_string : unit -> string ;
             (** Returns the XML document corresponding to this object *)
             
             method set_struct : string -> Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;
             (** Takes as argument, an element name and the schema that
             specifies the various attributes that need to be fixed *)

        end ;

(** An instance of the boolean_s_sig class *)
class boolean_s : boolean_s_sig ;

