(* Copyright (c) 2002 INRIA *)
(* Author : Gaurav Chanda , Projet CRISTAL *)

(** This module contains the description of the [date_s] class. *)

(** This is the lower bound of the [minInclusive] attribute *)
value date_mini : string ;

(** This is the lower bound of the [minExclusive] attribute *)
value date_mine : string ;

(** This is the upper bound of the [maxInclusive] attribute *)
value date_maxi : string ;

(** This is the upper bound of the [maxExclusive] attribute *)
value date_maxe : string ;

(** This gives the general description of the [boolean_s_sig] class *)
class type date_s_sig = 
        object
             
             value mutable name : string ;
             (** This contains the name of the XML-element concerned *)
             
             value mutable v : string ;
             (** This contains the value of the object *)
             
             value mutable is_enum : bool ;
             (** This indicates whether the type is an enumerated type *)
             
             value mutable is_fixed_maxi : bool ;
             (** This indicates whether the [maxInclusive] field of this object
               can be altered by a derived class *)

             value mutable is_fixed_maxe : bool ;
             (** This indicates whether the [maxExclusive] field of this object
               can be altered by a derived class *)

             value mutable is_fixed_mini : bool ;
             (** This indicates whether the [minInclusive] field of this object
               can be altered by a derived class *)

             value mutable is_fixed_mine : bool ;
             (** This indicates whether the [minExclusive] field of this object
               can be altered by a derived class *)

             value mutable enumlist : list string ;
             (** This contains the list of entries, required to define the
             enumerated type *)
             
             value mutable whitespace : string ;
             (** This contains the information on how to handle white spaces *)
             
             value mutable maxInclusive : string ;
             (** This contains information about the maximum inclusive bound of
             the type *)

             value mutable maxExclusive : string ;
             (** This contains information about the maximum exclusive bound of
             the type *)

             value mutable minInclusive : string ;
             (** This contains information about the minimum inclusive bound of
             the type *)

             value mutable minExclusive : string ;
             (** This contains information about the minimum exclusive bound of
             the type *)


             method get_val : unit -> string ;
             (** This function returns the value held by the object *)
             
             method set_obj : string -> unit ;
             (** Sets the value of the object with the given string after making
             other attribute checks *)
             
             method to_string : unit -> string ;
             (** Returns the XML document corresponding to this object *)
             
             method set_struct : string -> Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;
             (** Takes as argument, an element name and the schema that
             specifies the various attributes that need to be fixed *)

        end ;

(** An instance of the [date_s_sig] class *)
class date_s : date_s_sig ;
