(* Copyright (c) 2002 INRIA *)
(* Author : Gaurav Chanda , Projet CRISTAL *)

(** This module contains the description of the [gDay_s] type *)

(** This is the lower bound of the [minInclusive] attribute *)
value gDay_mini : string ;

(** This is the lower bound of the [minExclusive] attribute *)
value gDay_mine : string ;

(** This is the lower bound of the [maxInclusive] attribute *)
value gDay_maxi : string ;

(** This is the lower bound of the [maxExclusive] attribute *)
value gDay_maxe : string ;

(** This gives the general description of the [gDay_s_sig] class *)
class type gDay_s_sig = 
        object
             
             value mutable name : string ;
             (** This contains the name of the XML-element concerned *)
             
             value mutable v : string ;
             (** This contains the value of the object *)
             
             value mutable is_enum : bool ;
             (** This indicates whether the type is an enumerated type *)
             
             value mutable is_fixed_maxi : bool ;
             (** This indicates whether a derived class can have the
             [maxInclusive] field different from the parent class *)

             value mutable is_fixed_maxe : bool ;
             (** This indicates whether a derived class can have the
             [maxExclusive] field different from the parent class *)

             value mutable is_fixed_mini : bool ;
             (** This indicates whether a derived class can have the
             [minInclusive] field different from the parent class *)

             value mutable is_fixed_mine : bool ;
             (** This indicates whether a derived class can have the
             [minExclusive] field different from the parent class *)

             value mutable enumlist : list string ;
             (** This contains the list of entries required to define the
             enumerated type *)
             
             value mutable whitespace : string ;
             (** This contains information on how to handle white spaces *)
             
             value mutable maxInclusive : string ;
             (** This contains information on the maximum inclusive bound of the
             type *)

             value mutable maxExclusive : string ;
             (** This contains information on the maximum exclusive bound of the
             type *)

             value mutable minInclusive : string ;
             (** This contains information on the minimum inclusive bound of the
             type *)

             value mutable minExclusive : string ;
             (** This contains information on the minimum exclusive bound of the
             type *)


             method get_val : unit -> string ;
             (** This function returns the value held by the object *)
             
             method set_obj : string -> unit ;
             (** Sets the value of the object with the given string after making
             other attribute checks *)
             
             method to_string : unit -> string ;
             (** Returns the XMl document corresponding to this object *)
             
             method set_struct : string -> Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;
             (** Takes as argument, an element name and the schema that
             specifies various attributes that need to be fixed *)

        end ;

(** An instance of the [gDay_s_sig] class *)
class gDay_s : gDay_s_sig ;
