(** Interface of the OCaml-Soap library.

   Copyright (c) 2002 INRIA.
   @author Gaurav Chanda
*)

module PBase64Binary : 
        sig
value base64Binary_min : int ;
value base64Binary_max : int ;

class type base64Binary_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable length : int ;
             value mutable minLength : int ;
             value mutable maxLength : int ;
             value mutable is_enum : bool ;
             value mutable is_fixed : bool ;
             value mutable is_fixed_minl : bool ;
             value mutable is_fixed_maxl : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class base64Binary_s : base64Binary_s_sig ;
        end ;
        


        
module PBoolean : 
        sig
class type boolean_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : bool ;
             value mutable whitespace : string ;

             method get_val : unit -> bool ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class boolean_s : boolean_s_sig ;
        end ;
        



        
module PDate : 
        sig
value date_mini : string ;
value date_mine : string ;
value date_maxi : string ;
value date_maxe : string ;

class type date_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable is_enum : bool ;
             value mutable is_fixed_maxi : bool ;
             value mutable is_fixed_maxe : bool ;
             value mutable is_fixed_mini : bool ;
             value mutable is_fixed_mine : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;
             value mutable maxInclusive : string ;
             value mutable maxExclusive : string ;
             value mutable minInclusive : string ;
             value mutable minExclusive : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class date_s : date_s_sig ;
        end ;




module PDateTime : 
        sig
value dateTime_mini : string ;
value dateTime_mine : string ;
value dateTime_maxi : string ;
value dateTime_maxe : string ;

class type dateTime_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable is_enum : bool ;
             value mutable is_fixed_maxi : bool ;
             value mutable is_fixed_maxe : bool ;
             value mutable is_fixed_mini : bool ;
             value mutable is_fixed_mine : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;
             value mutable maxInclusive : string ;
             value mutable maxExclusive : string ;
             value mutable minInclusive : string ;
             value mutable minExclusive : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class dateTime_s : dateTime_s_sig ;
        end ;




module PDecimal : 
        sig
value decimal_mini : float ;
value decimal_mine : float ;
value decimal_maxi : float ;
value decimal_maxe : float ;

class type decimal_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : float ;
             value mutable totalDigits: int ;
             value mutable fractionDigits: int ;
             value mutable is_enum : bool ;
             value mutable is_fixed_td : bool ;
             value mutable is_fixed_fd : bool ;
             value mutable is_fixed_maxi : bool ;
             value mutable is_fixed_maxe : bool ;
             value mutable is_fixed_mini : bool ;
             value mutable is_fixed_mine : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;
             value mutable maxInclusive : float ;
             value mutable maxExclusive : float ;
             value mutable minInclusive : float ;
             value mutable minExclusive : float ;

             method get_val : unit -> float ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class decimal_s : decimal_s_sig ;
       end ;





module PDouble : 
        sig
value double_mini : float ;
value double_mine : float ;
value double_maxi : float ;
value double_maxe : float ;

class type double_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : float ;
             value mutable is_enum : bool ;
             value mutable is_fixed_maxi : bool ;
             value mutable is_fixed_maxe : bool ;
             value mutable is_fixed_mini : bool ;
             value mutable is_fixed_mine : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;
             value mutable maxInclusive : float ;
             value mutable maxExclusive : float ;
             value mutable minInclusive : float ;
             value mutable minExclusive : float ;

             method get_val : unit -> float ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class double_s : double_s_sig ;
        end ;





module PDuration : 
        sig
value duration_mini : string ;
value duration_mine : string ;
value duration_maxi : string ;
value duration_maxe : string ;

class type duration_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable is_enum : bool ;
             value mutable is_fixed_maxi : bool ;
             value mutable is_fixed_maxe : bool ;
             value mutable is_fixed_mini : bool ;
             value mutable is_fixed_mine : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;
             value mutable maxInclusive : string ;
             value mutable maxExclusive : string ;
             value mutable minInclusive : string ;
             value mutable minExclusive : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class duration_s : duration_s_sig ;
        end ;




module PFloat : 
        sig
value float_mini : float ;
value float_mine : float ;
value float_maxi : float ;
value float_maxe : float ;

class type float_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : float ;
             value mutable is_enum : bool ;
             value mutable is_fixed_maxi : bool ;
             value mutable is_fixed_maxe : bool ;
             value mutable is_fixed_mini : bool ;
             value mutable is_fixed_mine : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;
             value mutable maxInclusive : float ;
             value mutable maxExclusive : float ;
             value mutable minInclusive : float ;
             value mutable minExclusive : float ;

             method get_val : unit -> float ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class float_s : float_s_sig ;
        end ;






module PGDay : 
        sig
value gDay_mini : string ;
value gDay_mine : string ;
value gDay_maxi : string ;
value gDay_maxe : string ;

class type gDay_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable is_enum : bool ;
             value mutable is_fixed_maxi : bool ;
             value mutable is_fixed_maxe : bool ;
             value mutable is_fixed_mini : bool ;
             value mutable is_fixed_mine : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;
             value mutable maxInclusive : string ;
             value mutable maxExclusive : string ;
             value mutable minInclusive : string ;
             value mutable minExclusive : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class gDay_s : gDay_s_sig ;
        end ;




module PGMonthDay : 
        sig
value gMonthDay_mini : string ;
value gMonthDay_mine : string ;
value gMonthDay_maxi : string ;
value gMonthDay_maxe : string ;
             
class type gMonthDay_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable is_enum : bool ;
             value mutable is_fixed_maxi : bool ;
             value mutable is_fixed_maxe : bool ;
             value mutable is_fixed_mini : bool ;
             value mutable is_fixed_mine : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;
             value mutable maxInclusive : string ;
             value mutable maxExclusive : string ;
             value mutable minInclusive : string ;
             value mutable minExclusive : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class gMonthDay_s : gMonthDay_s_sig ;
        end ;





module PGMonth : 
        sig
value gMonth_mini : string ;
value gMonth_mine : string ;
value gMonth_maxi : string ;
value gMonth_maxe : string ;

class type gMonth_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable is_enum : bool ;
             value mutable is_fixed_maxi : bool ;
             value mutable is_fixed_maxe : bool ;
             value mutable is_fixed_mini : bool ;
             value mutable is_fixed_mine : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;
             value mutable maxInclusive : string ;
             value mutable maxExclusive : string ;
             value mutable minInclusive : string ;
             value mutable minExclusive : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class gMonth_s : gMonth_s_sig ;

        end ;




module PGYearMonth : 
        sig
value gYearMonth_mini : string ;
value gYearMonth_mine : string ;
value gYearMonth_maxi : string ;
value gYearMonth_maxe : string ;

class type gYearMonth_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable is_enum : bool ;
             value mutable is_fixed_maxi : bool ;
             value mutable is_fixed_maxe : bool ;
             value mutable is_fixed_mini : bool ;
             value mutable is_fixed_mine : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;
             value mutable maxInclusive : string ;
             value mutable maxExclusive : string ;
             value mutable minInclusive : string ;
             value mutable minExclusive : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class gYearMonth_s : gYearMonth_s_sig ;
        end ;





module PGYear : 
        sig
value gYear_mini : string ;
value gYear_mine : string ;
value gYear_maxi : string ;
value gYear_maxe : string ;

class type gYear_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable is_enum : bool ;
             value mutable is_fixed_maxi : bool ;
             value mutable is_fixed_maxe : bool ;
             value mutable is_fixed_mini : bool ;
             value mutable is_fixed_mine : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;
             value mutable maxInclusive : string ;
             value mutable maxExclusive : string ;
             value mutable minInclusive : string ;
             value mutable minExclusive : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class gYear_s : gYear_s_sig ;
        end ;





module PHexBinary : 
        sig
value hexBinary_min : int ;
value hexBinary_max : int ;

class type hexBinary_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable length : int ;
             value mutable minLength : int ;
             value mutable maxLength : int ;
             value mutable is_enum : bool ;
             value mutable is_fixed : bool ;
             value mutable is_fixed_minl : bool ;
             value mutable is_fixed_maxl : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class hexBinary_s : hexBinary_s_sig ;
        end ;





module PNotation : 
        sig
value notation_min : int ;
value notation_max : int ;

class type notation_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable length : int ;
             value mutable minLength : int ;
             value mutable maxLength : int ;
             value mutable is_enum : bool ;
             value mutable is_fixed : bool ;
             value mutable is_fixed_minl : bool ;
             value mutable is_fixed_maxl : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class notation_s : notation_s_sig ;
        end ;





module PQname : 
        sig
value qname_min : int ;
value qname_max : int ;

class type qname_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable length : int ;
             value mutable minLength : int ;
             value mutable maxLength : int ;
             value mutable is_enum : bool ;
             value mutable is_fixed : bool ;
             value mutable is_fixed_minl : bool ;
             value mutable is_fixed_maxl : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class qname_s : qname_s_sig ;
        end ;





module PString : 
        sig 
value string_min : int ;
value string_max : int ;

class type string_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable length : int ;
             value mutable minLength : int ;
             value mutable maxLength : int ;
             value mutable is_enum : bool ;
             value mutable is_fixed : bool ;
             value mutable is_fixed_minl : bool ;
             value mutable is_fixed_maxl : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class string_s : string_s_sig ;
       end ;





module PTime : 
        sig
value time_mini : string ;
value time_mine : string ;
value time_maxi : string ;
value time_maxe : string ;

class type time_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable is_enum : bool ;
             value mutable is_fixed_maxi : bool ;
             value mutable is_fixed_maxe : bool ;
             value mutable is_fixed_mini : bool ;
             value mutable is_fixed_mine : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;
             value mutable maxInclusive : string ;
             value mutable maxExclusive : string ;
             value mutable minInclusive : string ;
             value mutable minExclusive : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class time_s : time_s_sig ;
        end ;







module PUri : 
        sig
value uri_min : int ;
value uri_max : int ;

class type uri_s_sig = 
        object
             
             value mutable name : string ;
             value mutable v : string ;
             value mutable length : int ;
             value mutable minLength : int ;
             value mutable maxLength : int ;
             value mutable is_enum : bool ;
             value mutable is_fixed : bool ;
             value mutable is_fixed_minl : bool ;
             value mutable is_fixed_maxl : bool ;
             value mutable enumlist : list string ;
             value mutable whitespace : string ;

             method get_val : unit -> string ;
             method set_obj : string -> unit ;
             method to_string : unit -> string ;
             method set_struct : string ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;

        end ;

class uri_s : uri_s_sig ;
        end ;







(** This module contains the basic definition of various types that have been
implemented. Apart from definitions, some other functions are also defined which
enable interoperability between OCAML and SOAP-Types. *)
module PTypes : 
        sig
(*open String_s ;
open Boolean_s ;
open Decimal_s ;
open Float_s ; 
open Double_s ;
open Duration_s ;
open DateTime_s ;
open Time_s ;
open Date_s ;
open GYearMonth_s ;
open GYear_s ;
open GMonthDay_s ;
open GDay_s ;
open GMonth_s ;
open HexBinary_s ;
open Base64Binary_s ;
open Uri_s ;
open Qname_s ;
open Notation_s ;*)

(** This type contains the {i Primitive Datatypes} as defined in {b XML Schema
Part2: Datatypes} specification. Moreover, [array] and [struct] types are also
defined *)
type soapst = Hashtbl.t string ty
and ty = [ Unit 
         | String of String_s.string_s 
         | Boolean of Boolean_s.boolean_s 
         | Decimal of Decimal_s.decimal_s 
         | Float of Float_s.float_s 
         | Double of Double_s.double_s 
         | Duration of Duration_s.duration_s 
         | DateTime of DateTime_s.dateTime_s 
         | Time of Time_s.time_s 
         | Date of Date_s.date_s 
         | GYearMonth of GYearMonth_s.gYearMonth_s 
         | GYear of GYear_s.gYear_s 
         | GMonthDay of GMonthDay_s.gMonthDay_s 
         | GDay of GDay_s.gDay_s 
         | GMonth of GMonth_s.gMonth_s 
         | HexBinary of HexBinary_s.hexBinary_s 
         | Base64Binary of Base64Binary_s.base64Binary_s 
         | Uri of Uri_s.uri_s 
         | Qname of Qname_s.qname_s 
         | Notation of Notation_s.notation_s 
         | Array of array ty
         | Struct of Hashtbl.t string ty
         ];

(** This exception is thrown when there has been a type error *)
exception Bad_type ;

(** This creates a new [soapst] struct *)
value make_struct : unit -> soapst ;

(** Insert a new key/data pair into the struct *)
value add_elem : soapst -> string -> ty -> unit ;

(** Return the data for a key *)
value find_elem : soapst -> string -> ty ;



(** {2 Convert ML Types to SOAP - types} *)

(** Converts a ML string, represented as a [string_s] object into a SOAP object *)
value sp_of_string : String_s.string_s -> ty ;

(** Converts a ML bool, represented as a [boolean_s] object into a SOAP object *)
value sp_of_boolean : Boolean_s.boolean_s -> ty ;

(** Converts a ML decimal, represented as a [decimal_s] object into a SOAP object *)
value sp_of_decimal : Decimal_s.decimal_s -> ty ;

(** Converts a ML float, represented as a [float_s] object into a SOAP object *)
value sp_of_float : Float_s.float_s -> ty ;

(** Converts a ML double, represented as a [double_s] object into a SOAP object *)
value sp_of_double : Double_s.double_s -> ty ;

(** Converts a ML duration, represented as a [duration_s] object into a SOAP object *)
value sp_of_duration : Duration_s.duration_s -> ty ;

(** Converts a ML dateTime, represented as a [dateTime_s] object into a SOAP object *)
value sp_of_dateTime : DateTime_s.dateTime_s -> ty ; 

(** Converts a ML time, represented as a [time_s] object into a SOAP object *)
value sp_of_time : Time_s.time_s -> ty ;

(** Converts a ML date, represented as a [date_s] object into a SOAP object *)
value sp_of_date : Date_s.date_s -> ty ;

(** Converts a ML gYearMonth, represented as a [gYearMonth_s] object into a SOAP object *)
value sp_of_gYearMonth : GYearMonth_s.gYearMonth_s -> ty ;

(** Converts a ML gYear, represented as a [gYear_s] object into a SOAP object *)
value sp_of_gYear : GYear_s.gYear_s -> ty ;

(** Converts a ML gMonthDay, represented as a [gMonthDay_s] object into a SOAP object *)
value sp_of_gMonthDay : GMonthDay_s.gMonthDay_s -> ty ;

(** Converts a ML gDay, represented as a [gDay_s] object into a SOAP object *)
value sp_of_gDay : GDay_s.gDay_s -> ty ;

(** Converts a ML gMonth, represented as a [gMonth_s] object into a SOAP object *)
value sp_of_gMonth : GMonth_s.gMonth_s -> ty ;

(** Converts a ML hexBinary, represented as a [hexBinary_s] object into a SOAP object *)
value sp_of_hexBinary : HexBinary_s.hexBinary_s -> ty ;

(** Converts a ML base64Binary, represented as a [base64Binary_s] object into a SOAP object *)
value sp_of_base64Binary : Base64Binary_s.base64Binary_s -> ty ;

(** Converts a ML uri, represented as a [uri_s] object into a SOAP object *)
value sp_of_uri : Uri_s.uri_s -> ty ;

(** Converts a ML qname, represented as a [qname_s] object into a SOAP object *)
value sp_of_qname : Qname_s.qname_s -> ty ;

(** Converts a ML notation, represented as a [notation_s] object into a SOAP object *)
value sp_of_notation : Notation_s.notation_s -> ty ;

(** Converts a ML array, into a SOAP object *)
value sp_of_array : array ty -> ty ;

(** Converts a ML struct, represented as [soapst], into a SOAP object *)
value sp_of_struct : soapst -> ty ;

(** SOAP representation of UNIT *)
value skip : ty ;




(** {2 Convert SOAP Types to ML Types} *)

(** Converts a SOAP string into a ML string value *)
value ml_of_string : ty -> String_s.string_s ;

(** Converts a SOAP boolean into a ML boolean value *)
value ml_of_boolean : ty -> Boolean_s.boolean_s ;

(** Converts a SOAP decimal into a ML decimal value *)
value ml_of_decimal : ty -> Decimal_s.decimal_s ;

(** Converts a SOAP float into a ML float value *)
value ml_of_float : ty -> Float_s.float_s ;

(** Converts a SOAP double into a ML double value *)
value ml_of_double : ty -> Double_s.double_s ;

(** Converts a SOAP duration into a ML duration value *)
value ml_of_duration : ty -> Duration_s.duration_s ;

(** Converts a SOAP dateTime into a ML dateTime value *)
value ml_of_dateTime : ty -> DateTime_s.dateTime_s ;

(** Converts a SOAP time into a ML time value *)
value ml_of_time : ty -> Time_s.time_s ;

(** Converts a SOAP date into a ML date value *)
value ml_of_date : ty -> Date_s.date_s ;

(** Converts a SOAP gYearMonth into a ML gYearMonth value *)
value ml_of_gYearMonth : ty -> GYearMonth_s.gYearMonth_s ;

(** Converts a SOAP gYear into a ML gYear value *)
value ml_of_gYear : ty -> GYear_s.gYear_s ;

(** Converts a SOAP gMonthDay into a ML gMonthDay value *)
value ml_of_gMonthDay : ty -> GMonthDay_s.gMonthDay_s ;

(** Converts a SOAP gDay into a ML gDay value *)
value ml_of_gDay : ty -> GDay_s.gDay_s ;

(** Converts a SOAP gMonth into a ML gMonth value *)
value ml_of_gMonth : ty -> GMonth_s.gMonth_s ;

(** Converts a SOAP hexBinary into a ML hexBinary value *)
value ml_of_hexBinary : ty -> HexBinary_s.hexBinary_s ;

(** Converts a SOAP base64Binary into a ML base64Binary value *)
value ml_of_base64Binary : ty -> Base64Binary_s.base64Binary_s ;

(** Converts a SOAP uri into a ML uri value *)
value ml_of_uri : ty -> Uri_s.uri_s ;

(** Converts a SOAP qname into a ML qname value *)
value ml_of_qname : ty -> Qname_s.qname_s ;

(** Converts a SOAP notation into a ML notation value *)
value ml_of_notation : ty -> Notation_s.notation_s ;

(** Converts a SOAP array into a ML array value *)
value ml_of_array : ty -> array ty ;

(** Converts a SOAP struct into a ML struct value *)
value ml_of_struct : ty -> soapst ;

(** Converts a SOAP string array into a ML string array value *)
value ml_of_stringarray : ty -> array String_s.string_s ;

(** Converts a SOAP boolean array into a ML boolean array value *)
value ml_of_booleanarray : ty -> array Boolean_s.boolean_s ;

(** Converts a SOAP decimal array into a ML decimal array value *)
value ml_of_decimalarray : ty -> array Decimal_s.decimal_s ;

(** Converts a SOAP float array into a ML float array value *)
value ml_of_floatarray : ty -> array Float_s.float_s ;

(** Converts a SOAP double array into a ML double array value *)
value ml_of_doublearray : ty -> array Double_s.double_s ;

(** Converts a SOAP duration array into a ML duration array value *)
value ml_of_durationarray : ty -> array Duration_s.duration_s ;

(** Converts a SOAP dateTime array into a ML dateTime array value *)
value ml_of_dateTimearray : ty -> array DateTime_s.dateTime_s ;

(** Converts a SOAP time array into a ML time array value *)
value ml_of_timearray : ty -> array Time_s.time_s ;

(** Converts a SOAP date array into a ML date array value *)
value ml_of_datearray : ty -> array Date_s.date_s ;

(** Converts a SOAP gYearMonth array into a ML gYearMonth array value *)
value ml_of_gYearMontharray : ty -> array GYearMonth_s.gYearMonth_s ;

(** Converts a SOAP gYear array into a ML gYear array value *)
value ml_of_gYeararray : ty -> array GYear_s.gYear_s ;

(** Converts a SOAP gMonthDay array into a ML gMonthDay array value *)
value ml_of_gMonthDayarray : ty -> array GMonthDay_s.gMonthDay_s ;

(** Converts a SOAP gDay into a ML gDay value *)
value ml_of_gDayarray : ty -> array GDay_s.gDay_s ;

(** Converts a SOAP gMonth into a ML gMonth value *)
value ml_of_gMontharray : ty -> array GMonth_s.gMonth_s ;

(** Converts a SOAP struct array into a ML struct array value *)
value ml_of_structarray : ty -> array soapst ;

(** {2 Other} *)

(** This function takes as argument, a schema, a Pxp document node (containing
the input whose SOAP value is to be determined, and a string which contains its
type description. The resultant SOAP value is returned *)
value parse_value : Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> string -> ty ;

(** Prints the SOAP object into a string *)
value print_value : ty -> string ;

        end ;





(** This module gives a description of the OCAML structure, which represents
a standard soap message *)
module PStructure : 
        sig
(** The attributes are named under the [qname] type *)
type qname = [QName of string] ;

(** All the attributes of the [attributehandler] are stored into a
structure of type [table]*)
type table = Hashtbl.t qname string ;

(** [Bad_argument] is raised when there is an erroneous parameter passing
going on in the program *)
exception Bad_argument ;

(** [No_header_present] is raised when the header field of a soap message is
being accessed and the message does not have any *)
exception No_header_present ;

(** This class handles the various attributes and namespaces of different
elements *)
class type attributehandler = 
        object 
                value attributes : table ;
                (** The storehouse of all the attributes present *)

                value namespace_list : ref (list (string * string)) ;
                (** The storehouse of all the declared namespaces *)

                method set_attr : qname -> string -> unit;
                (** Adds/changes an attribute *)

                method get_attr : qname -> string ;
                (** Returns the value of an attribute *)

                method rem_attr : qname -> unit;
                (** Removes the attribute from the [attributes] structure *)

                method declareNS : string -> string -> unit;
                (** Declares a new namespace in the element *)

                method ns_to_string : unit -> string ;
                (** Prints all the namespaces into a string *)

                method att_to_string : unit -> string ;
                (** Prints all the attributes into a string *)

                method to_string : unit -> string;
                (** Prints all the attributes and namespaces into a string *)
        end ;


(** This class encapsulates the entries of the header class *)
class type header_entry = 
        object
                value entry_name : string ;
                (** This is the name of the corresponding element *)

                value v : SoapTypes.ty ;
                (* This will be value the of the type SoapTypes.ty *)
                
                value sch : Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a));
                (** This will be the schema node of the type of value that the
                entry contains *)

                value attr_handl : attributehandler;
                (** This is the handler of all the attributes and namespaces of
                the [header] object *)
                
                method setname : string -> unit ;
                (** Assigns the element name to the [header_entry] object *)

                method getname : unit -> string ;
                (** Returns the corresponding element name of the [header_entry]
                object *)

                method setval : SoapTypes.ty -> unit ;
                (** Assigns the element value to the [header_entry] object *)

                method getval : unit -> SoapTypes.ty ;
                (** Returns the corresponding element value of the [header_entry]
                object *)

                method set_sch :  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;
                (** Sets the [sch] field of the object *)
                
                method get_sch : unit ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) ;
                (** Returns the [sch] field of the object *)

                method set_attr : qname -> string -> unit;
                (** Adds/changes an attribute *)

                method get_attr : qname -> string;
                (** Returns the value of an  attribute *)

                method rem_attr : qname -> unit;
                (** Removes the attribute from the [header] structure *)

                method declareNS : string -> string -> unit;
                (** Declares a namespace in the [header] structure *)

                method to_string : unit -> string ;
                (** Prints the header portion of the soap message into a string
                *)
       end ;


(** This class encapsulates the header portion of the soap message *)
class type header =
        object 
                value entry_list : list header_entry;
                (** This is the storehouse of all the entries of the [header]
                structure *)

                method add_entry : header_entry -> unit ;
                (** Adds a new entry to the [header] structure *)

                method rem_entry : header_entry -> list header_entry -> list header_entry ;
                (** Removes a [header_entry] from a list *)

                method get_entrylist : unit -> list header_entry ;
                (** Returns the list of header entries *)
                
                method to_string : unit -> string ;
                (** Prints the header portion of the soap message into a string
                *)
       end ;


(** This class encapsulates the entries of the body class *)
class type body_entry = 
        object
                value entry_name : string ;
                (** This is the name of the corresponding element *)

                value v : SoapTypes.ty ;
                (* This will be the of the type SoapTypes.ty *)

                value sch : Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a));
                (** This will be the schema node of the type of value that the
                entry contains *)

                value attr_handl : attributehandler;
                (** This is the handler of all the attributes and namespaces of
                the [body] object *)
                
                method setname : string -> unit ;
                (** Assigns the element name to the [body_entry] object *)

                method getname : unit -> string ;
                (** Returns the corresponding element name of the [body_entry]
                object *)

                method setval : SoapTypes.ty -> unit ;
                (** Assigns the element value to the [body_entry] object *)

                method getval : unit -> SoapTypes.ty ;
                (** Returns the corresponding element value of the [body_entry]
                object *)

                method set_sch :  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) -> unit ;
                (** Sets the [sch] field of the object *)
                
                method get_sch : unit ->  Pxp_document.node (Pxp_document.extension (Pxp_document.node 'a)) ;
                (** Returns the [sch] field of the object *)

                method set_attr : qname -> string -> unit;
                (** Adds/changes an attribute *)

                method get_attr : qname -> string;
                (** Returns the value of an  attribute *)

                method rem_attr : qname -> unit;
                (** Removes the attribute from the [body] structure *)

                method declareNS : string -> string -> unit;
                (** Declares a namespace in the [body] structure *)

                method to_string : unit -> string ;
                (** Prints the body portion of the soap message into a string
                *)
       end ;


(** This class encapsulates the body portion of the soap message *)
class type body =
        object 
                value entry_list : list body_entry;
                (** This is the storehouse of all the entries of the [body]
                structure *)

                method add_entry : body_entry -> unit ;
                (** Adds a new entry to the [body] structure *)

                method rem_entry : body_entry -> list body_entry -> list body_entry ;
                (** Removes a [body_entry] from a list *)

                method get_entrylist : unit -> list body_entry ;
                (** Returns the list of body entries *)
                
                method to_string : unit -> string ;
                (** Prints the body portion of the soap message into a string
                *)
       end ;


(** This class encapsulates the envelope portion of the soap message. In fact, a
soap message is essentially an [envelope] object which itself consists of a
[body], an {i optional } [header] etc. *)
class type envelope =
        object 
                value header : ref (option header);
                (** This is the header part of the soap message. Since it can be
                optional, it is declared as a [option header] *)
                
                value body : ref body;
                (** This is the body part of the soap message *)
                
                value env_entries : ref (list string) ;
                (** This is the storehouse of all the entries of the [envelope]
                structure *)

                value attr_handl : attributehandler ;
                (** This is the handler of all the attributes and namespaces of
                the [envelope] object *)
                
                method init : unit -> unit ;
                (** This function initializes an envelope with the default namespaces
                and uris *)

                method set_attr : qname -> string -> unit;
                (** Adds/changes an attribute *)

                method get_attr : qname -> string;
                (** Returns the value of an  attribute *)

                method rem_attr : qname -> unit;
                (** Removes the attribute from the [envelope] structure *)

                method declareNS : string -> string -> unit;
                (** Declares a namespace in the [envelope] structure *)

                method set_header : option header -> unit;
                (** Sets the [header] of the message *)

                method get_header : unit -> header ;
                (** Returns the [header] of the message *)

                method set_body : body -> unit;
                (** Sets the [body] of the message *)

                method get_body : unit -> body;
                (** Returns the body of the message *)

                method set_env_entr : list string -> unit;
                (** Adds new entries in the [envelope] structure *)

                method get_env_entr : unit -> list string; 
                (** Returns the envelope entries *)

                method conv_string : unit -> string ;
                (** Prints the envelope portion of the soap message into a string *)
       end ;


(** This class encapsulates the fault portion of the soap message. Actually, it
is a special type of soap body. But because of difference in structure and
meaning, it has been treated separately. *)
class type fault = 
        object
                value faultCode : ref string;
                (** This contains the fault code of the fault message *)
                
                value faultString : ref string ;
                (** This contains the fault string of the fault message *)
                
                value faultActorUri : ref string ;
                (** This contains the URI of the fault causing node *)
                
                value detail_entries : ref (list string);
                (** This is the storehouse of all the detail entries of the
                [fault] structure *)

                value fault_entries : ref (list string);
                (** This is the storehouse of all the fault entries of the
                [fault] structure *)

                value attr_handl : attributehandler ;
                (** This is the handler of all the attributes and namespaces of
                the [fault] object *)

                method set_attr : qname -> string -> unit ;
                (** Adds/changes an attribute *)

                method get_attr : qname -> string ;
                (** Returns the value of an  attribute *)

                method rem_attr : qname -> unit ;
                (** Removes the attribute from the [fault] structure *)

                method declareNS : string -> string -> unit ;
                (** Declares a namespace in the [fault] structure *)

                method set_fault_code : string -> unit ;
                (** Sets the fault code of the [fault] structure *)

                method get_fault_code : unit -> string ;
                (** Returns the fault code of the [fault] structure *)

                method set_fault_string : string -> unit ;
                (** Sets the fault string of the [fault] structure *)

                method get_fault_string : unit -> string ;
                (** Returns the fault string of the [fault] structure *)

                method set_faultactor_uri : string -> unit;
                (** Sets the URI of the fault actor  of the [fault] *)

                method get_faultactor_uri : unit -> string ;
                (** Returns the URI of the fault actor  of the [fault] *)

                method set_fault_entr : list string -> unit ;
                (** Adds new entries in the [fault] structure *)

                method get_fault_entr : unit -> list string ; 
                (** Returns the fault entries *)

                method to_string : unit -> string ;
                (** Prints the fault portion of the soap message into a string *)
       end ;

(** Given an XML document and an envelope object containing the attributes, this function returns an
[envelope] object *)
value get_obj : envelope -> string -> envelope ;

(** Given an XML document containing a soap schema, this function returns an
[envelope] object *)
value get_obj_struct : string -> envelope ;

(** Given an [envelope] object, this function returns the corresponding XML
document *)
value get_string : envelope -> string ;
       
     end ;
